//**************************************************************
// LiteCAD Application Demo
// About Form Unit
// harry200@gmail.com
//**************************************************************

unit about;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  ExtCtrls, Buttons, Shellapi, System.UITypes, WinApi.Activex,
  Vcl.ComCtrls, Vcl.Graphics, Vcl.StdCtrls;

type
  TAboutForm = class(TForm)
    Bevel1: TBevel;
    Panel1: TPanel;
    Image1: TImage;
    LabelVersion: TLabel;
    SpeedButtonClose: TSpeedButton;
    LabelVendor: TLabel;
    LabelNameApp: TLabel;
    LabelNameApp2: TLabel;
    LabelSite: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpeedButtonCloseClick(Sender: TObject);
    procedure LabelSiteClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
 end;

var
  AboutForm: TAboutForm;

implementation

{$R *.dfm}

uses res;

// procedure ShellExec
// Ref: http://www.gunsmoker.ru/2015/01/never-use-ShellExecute.html
procedure ShellExec(const AWnd: HWND; const AOperation, AFileName: String;
                    const AParameters: String = ''; const ADirectory: String = '';
                    const AShowCmd: Integer = SW_SHOWNORMAL);
var
  ExecInfo: TShellExecuteInfo;
  NeedUnitialize: Boolean;
begin
  Assert(AFileName <> EmptyStr);
  NeedUnitialize := Succeeded(CoInitializeEx(nil, COINIT_APARTMENTTHREADED or COINIT_DISABLE_OLE1DDE));
  try
    FillChar(ExecInfo, SizeOf(ExecInfo), 0);
    ExecInfo.cbSize := SizeOf(ExecInfo);
    ExecInfo.Wnd := AWnd;
    ExecInfo.lpVerb := Pointer(AOperation);
    ExecInfo.lpFile := PChar(AFileName);
    ExecInfo.lpParameters := Pointer(AParameters);
    ExecInfo.lpDirectory := Pointer(ADirectory);
    ExecInfo.nShow := AShowCmd;
    ExecInfo.fMask := SEE_MASK_NOASYNC { = SEE_MASK_FLAG_DDEWAIT old version of Delphi }
                   or SEE_MASK_FLAG_NO_UI;
    {$IFDEF UNICODE}
    ExecInfo.fMask := ExecInfo.fMask or SEE_MASK_UNICODE;
    {$ENDIF}

    {$WARN SYMBOL_PLATFORM OFF}
    Win32Check(ShellExecuteEx(@ExecInfo));
    {$WARN SYMBOL_PLATFORM ON}
  finally
    if NeedUnitialize then CoUninitialize;
  end;
end;

procedure TAboutForm.FormCreate(Sender: TObject);
begin
  LabelNameApp.Caption   := GetAppName;
  LabelNameApp2.Caption  := GetAppName;
  LabelVendor.Caption    := GetAppVend;
  LabelVersion.Caption   := GetAppVersion(Paramstr(0)){$IFDEF WIN64}+'(x64)'{$ENDIF};
  LabelSite.Caption      := AppSite;
end;

procedure TAboutForm.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  const SC_DragMove = $F012;
begin
  ReleaseCapture;
  AboutForm.perform(WM_SysCommand,SC_DragMove,0);
end;

procedure TAboutForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key=VK_ESCAPE) then Close;
end;

procedure TAboutForm.LabelSiteClick(Sender: TObject);
begin
  ShellExec(Handle,EmptyStr,AppSite,EmptyStr,EmptyStr,SW_SHOWNORMAL);
end;

procedure TAboutForm.SpeedButtonCloseClick(Sender: TObject);
begin
  Close
end;

end.
